aboutsummaryrefslogtreecommitdiff
path: root/contrib/update-unicode/update_unicode.sh
diff options
context:
space:
mode:
authorBeat Bolli <dev+git@drbeat.li>2016-12-14 00:31:39 +0100
committerJunio C Hamano <gitster@pobox.com>2016-12-13 16:12:47 -0800
commitf3eb54920eff356a30df144d50b45a5581e5eb13 (patch)
tree34be6ffc87b5ec37419a587fe00c0a613da39b08 /contrib/update-unicode/update_unicode.sh
parent32c239d1fb23d47aa95cc8a47f99dc25f152021d (diff)
downloadgit-f3eb54920eff356a30df144d50b45a5581e5eb13.tar.gz
git-f3eb54920eff356a30df144d50b45a5581e5eb13.tar.xz
update_unicode.sh: move it into contrib/update-unicode
As it's used only by a tiny minority of the Git developer population, this script does not belong into the main Git source directory. Move it into contrib/ and adjust the paths to account for the new location. Signed-off-by: Beat Bolli <dev+git@drbeat.li> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'contrib/update-unicode/update_unicode.sh')
-rwxr-xr-xcontrib/update-unicode/update_unicode.sh38
1 files changed, 38 insertions, 0 deletions
diff --git a/contrib/update-unicode/update_unicode.sh b/contrib/update-unicode/update_unicode.sh
new file mode 100755
index 000000000..7b901266c
--- /dev/null
+++ b/contrib/update-unicode/update_unicode.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+#See http://www.unicode.org/reports/tr44/
+#
+#Me Enclosing_Mark an enclosing combining mark
+#Mn Nonspacing_Mark a nonspacing combining mark (zero advance width)
+#Cf Format a format control character
+#
+cd "$(dirname "$0")"
+UNICODEWIDTH_H=$(git rev-parse --show-toplevel)/unicode_width.h
+(
+ if ! test -f UnicodeData.txt; then
+ wget http://www.unicode.org/Public/UCD/latest/ucd/UnicodeData.txt
+ fi &&
+ if ! test -f EastAsianWidth.txt; then
+ wget http://www.unicode.org/Public/UCD/latest/ucd/EastAsianWidth.txt
+ fi &&
+ if ! test -d uniset; then
+ git clone https://github.com/depp/uniset.git
+ fi &&
+ (
+ cd uniset &&
+ if ! test -x uniset; then
+ autoreconf -i &&
+ ./configure --enable-warnings=-Werror CFLAGS='-O0 -ggdb'
+ fi &&
+ make
+ ) &&
+ UNICODE_DIR=. && export UNICODE_DIR &&
+ cat >$UNICODEWIDTH_H <<-EOF
+ static const struct interval zero_width[] = {
+ $(uniset/uniset --32 cat:Me,Mn,Cf + U+1160..U+11FF - U+00AD |
+ grep -v plane)
+ };
+ static const struct interval double_width[] = {
+ $(uniset/uniset --32 eaw:F,W)
+ };
+ EOF
+)